﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Train
{
    
    public partial class frmDataInput3 : Form
    {
        private DataItemTrain data;
        private bool cancel = true;
        public frmDataInput3()
        {
            InitializeComponent();
        }

        public DialogResult ShowFormAndInput(DataItemTrain Data)
        {
            data = Data;
            SetData();
            if (ShowDialog() == DialogResult.OK)
            {
                GetData();
                return DialogResult.OK;
            }
            else
            {
                return DialogResult.Cancel;
            }
        }

        private bool CheckInputData()
        {
            // Überprüfung der Eingabedaten
            return true;
        }

        private void GetData()
        {
            // Auslesen der Werte aus dem Formular
            data.Adress = int.Parse(comboBoxAdress.Text);
            data.Description = textBoxDescription.Text;
        }

        private void SetData()
        {
            comboBoxAdress.Text = data.Adress.ToString();
            if (data.Adress == 0) comboBoxAdress.Text = "";
            textBoxDescription.Text = data.Description;
            textBoxIcon.Text = Path.GetFileName(data.IconFileName);
            string filename = Application.StartupPath + "\\icons\\" + data.IconFileName;
            try
            {
                pictureBoxIcon.Image = Image.FromFile(filename);
            }
            catch
            { }

        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            cancel = true;
        }

        private void frmDataInput3_FormClosing(object sender, FormClosingEventArgs e)
        {
            if ((cancel == false) && (CheckInputData() == false))
            {
                e.Cancel = true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                data.IconFileName = Path.GetFileName(openFileDialog.FileName);
                textBoxIcon.Text = Path.GetFileName(data.IconFileName);
                string filename = Application.StartupPath + "\\icons\\" + data.IconFileName;
                try
                {
                    pictureBoxIcon.Image = Image.FromFile(filename);
                }
                catch
                { }

            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            cancel = false;
            Close();
        }


    }
}
