﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Train
{
    public partial class frmLigth : Form
    {
        private int currentIndex = 1;
        private Data daten;
        private CheckBox[] checkbox = new CheckBox[12];
        public frmLigth()
        {
            InitializeComponent();
        }
        public void ShowFormAndInput(Data Daten)
        {
            daten = Daten;
            ShowDialog();
        }
        private void ShowButton(int StartIndex, int EndIndex )
        {
            for (int i = 0; i < checkbox.Length; i++)
            {
                    this.flowLayoutPanel1.Controls.Remove(checkbox[i]);        
            }

            for (int i = 0; i < (EndIndex-StartIndex+1); i++)
            {
                checkbox[i] = new CheckBox();
                checkbox[i].Appearance = System.Windows.Forms.Appearance.Button;
                checkbox[i].BackColor = System.Drawing.Color.Gainsboro;
                checkbox[i].Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                checkbox[i].ImageAlign = System.Drawing.ContentAlignment.BottomRight;
                checkbox[i].Location = new System.Drawing.Point(10, 10);
                checkbox[i].Margin = new System.Windows.Forms.Padding(10);
                checkbox[i].Size = new System.Drawing.Size(234, 74);
                checkbox[i].TextAlign = System.Drawing.ContentAlignment.TopLeft;
                checkbox[i].UseVisualStyleBackColor = false;
                checkbox[i].Text = daten.LigthData[StartIndex + i - 1].Headline;
                checkbox[i].Tag = StartIndex + i - 1; // Index zuweisen
                try
                {
                    string filename = Application.StartupPath + "\\icons\\" + daten.LigthData[StartIndex + i - 1].IconFileName;
                    checkbox[i].Image = Image.FromFile(filename);
                }
                catch
                {
                }
                checkbox[i].Checked = daten.LigthData[StartIndex + i - 1].Status;
                if (checkbox[i].Checked == true)
                    checkbox[i].BackColor = Color.DarkOrange;
                else
                    checkbox[i].BackColor = Color.Gainsboro;
                checkbox[i].Click += new EventHandler(checkBoxClick);
                //
                this.flowLayoutPanel1.Controls.Add(checkbox[i]);
            }
        }
        private void ClickCheckBox(int Index, bool CheckALL)
        {
            int indexCheckbox = Index;
            while (indexCheckbox>11)
            {
                indexCheckbox = indexCheckbox - 12;
            }
            checkbox[indexCheckbox].Checked = daten.LigthData[Index].Status;
            int adress = daten.LigthData[Index].Adress;
            if (daten.LigthData[Index].Chance == false)
            {
                CommunicationToInterface.Ligth(adress, checkbox[indexCheckbox].Checked);
            }
            else
            {
                CommunicationToInterface.Ligth(adress, !checkbox[indexCheckbox].Checked);
            }

            if (checkbox[indexCheckbox].Checked == true)
                checkbox[indexCheckbox].BackColor = Color.DarkOrange;
            else
                checkbox[indexCheckbox].BackColor = Color.Gainsboro;

            // Prüfen, ob alle Lichter der Modellbahn angeschaltet bzw. ausgeschaltet sind
            if (CheckALL == true)
            {
                bool allOn = true;
                for (int i = 0; i < daten.LigthData.Count; i++)
                {
                    if (daten.LigthData[i].Status == false)
                    {
                        allOn = false;
                        break;
                    }
                }
                if (allOn == true)
                {
                    checkBoxAll.BackColor = Color.DarkOrange;
                    checkBoxAll.Checked = true;
                }
                else
                {
                    checkBoxAll.BackColor = Color.Gainsboro;
                    checkBoxAll.Checked = false;
                }
            }

        }
        private void checkBoxClick(object sender, EventArgs e)
        {
            CheckBox checkbox = (CheckBox)sender;
            int index = (int)checkbox.Tag;
            daten.LigthData[index].Status = !daten.LigthData[index].Status;
            ClickCheckBox(index, true);
            
        }
        private void frmLigth_Load(object sender, EventArgs e)
        {
            int number;
            if (daten.LigthData.Count >= 12)
            {
                number = 12;
                if (daten.LigthData.Count > 12) buttonPre.Enabled = true;
            }
            else
            {
                number = daten.LigthData.Count;
                buttonPre.Enabled = false;
                buttonBack.Enabled = false;
            }
            ShowButton(1, number);
        }
        private void buttonPre_Click(object sender, EventArgs e)
        {
            currentIndex = currentIndex + 12;
            int endIndex = currentIndex + 11;
            if (endIndex > daten.LigthData.Count) endIndex = daten.LigthData.Count;
            buttonBack.Enabled = true;
            if (endIndex <= daten.LigthData.Count)
            {
                buttonPre.Enabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }
        private void buttonBack_Click(object sender, EventArgs e)
        {
            currentIndex = currentIndex -12;
            int endIndex = currentIndex + 11;
            buttonPre.Enabled = true;
            if (currentIndex <= 1)
            {
                buttonBack.Enabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }
        private void checkBoxAll_Click(object sender, EventArgs e)
        {
            // alle Lampen an bzw. ausschalten
            for (int i = 0; i < daten.LigthData.Count; i++)
            {
                daten.LigthData[i].Status = checkBoxAll.Checked;
                ClickCheckBox(i, false);
                Application.DoEvents();
            }

            if (checkBoxAll.Checked == true)
            {
                checkBoxAll.BackColor = Color.DarkOrange;
            }
            else
            {
                checkBoxAll.BackColor = Color.Gainsboro;
            }
        }
    }
}
