﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace Train
{
    public partial class FormMain : Form
    {
        private enum StatusOfSystem { on, off };
        private StatusOfSystem status= StatusOfSystem.off;
        private Data Daten = new Data();
        public FormMain()
        {
            InitializeComponent();
            Thread th = new Thread(new ThreadStart(DoSplash));
            th.Start();
            Thread.Sleep(1000);
            th.Abort();
            Thread.Sleep(1000);
        }
        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void DoSplash()
        {

            frmSplash sp = new frmSplash();
            sp.ShowDialog();

        }
        private void button1_Click(object sender, EventArgs e)
        {
             Light();
        }
        private void Drive()
        {
            frmTrain formTrain = new frmTrain();
            formTrain.ShowFormAndInput(Daten);
        }
        private void Light()
        {
            frmLigth formLight = new frmLigth();
            formLight.ShowFormAndInput(Daten);
        }
        private void Signal()
        {
            frmSignal formSignal = new frmSignal();
            formSignal.ShowFormAndInput(Daten);
        }
        private void Konfiguration_Lichtsteuerung_Click(object sender, EventArgs e)
        {
            frmConfiguration formConfiguration = new frmConfiguration();
            formConfiguration.ShowFormAndInput(Daten);
        }
        private void FormMain_Load(object sender, EventArgs e)
        {
            string dir = Application.CommonAppDataPath + "Daten.xml";
            if (File.Exists(dir))
            {
                Daten = Data.LoadFromXml(dir);
            }
        }
        private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            string dir = Application.CommonAppDataPath + "Daten.xml";
            Daten.SaveAsXml(dir);
        }
        private void infoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout formAbout = new frmAbout();
            formAbout.ShowDialog();
        }
        private void importToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                Daten = Data.LoadFromXml(openFileDialog.FileName);
            }
        }
        private void exportToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                Daten.SaveAsXml(saveFileDialog.FileName);
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void button3_Click(object sender, EventArgs e)
        {
            Signal();
        }
        private void Konfiguration_Signalsteuerung_Click(object sender, EventArgs e)
        {
            frmConfiguration2 formConfiguration2 = new frmConfiguration2();
            formConfiguration2.ShowFormAndInput(Daten);
        }
        private void lichtsteuerungToolStripMenuItem2_Click(object sender, EventArgs e)
        {
            Light();
        }
        private void signalsteuerungToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Signal();
        }
        private void button4_Click(object sender, EventArgs e)
        {
            if (status == StatusOfSystem.on)
            {
                status = StatusOfSystem.off;
                buttonStartStopp.Text = "Alles Stop";
                buttonStartStopp.BackgroundImage = Train.Properties.Resources.stop;
                buttonStartStopp.BackColor = Color.Red;
                CommunicationToInterface.AllOff();
            }
            else
            {
                status = StatusOfSystem.on;
                buttonStartStopp.Text = "Alles an";
                buttonStartStopp.BackgroundImage = Train.Properties.Resources.start;
                buttonStartStopp.BackColor = Color.Green;
                CommunicationToInterface.AllOn();

            }
        }
        private void button4_Click_1(object sender, EventArgs e)
        {
            Drive();
        }
        private void zugsteuerungToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            frmConfiguration3 formConfiguration3 = new frmConfiguration3();
            formConfiguration3.ShowFormAndInput(Daten);
        }
    }
}
