﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Train
{
    public partial class frmSignal : Form
    {
       
        public frmSignal()
        {
            InitializeComponent();
        }
        private Data daten;
        private int currentIndex = 1;
        private Button[] button = new Button[12];
        public void ShowFormAndInput(Data Daten)
        {
            daten = Daten;
            ShowDialog();
        }
        private void ShowButton(int StartIndex, int EndIndex)
        {
            for (int i = 0; i < button.Length; i++)
            {
                this.flowLayoutPanel1.Controls.Remove(button[i]);
            }

            for (int i = 0; i < (EndIndex-StartIndex+1); i++)
            {

                button[i] = new Button();
                button[i].BackColor = System.Drawing.Color.Red;
                button[i].Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                button[i].Location = new System.Drawing.Point(15, 15);
                button[i].Margin = new System.Windows.Forms.Padding(15);
                button[i].Name = "button1";
                button[i].Size = new System.Drawing.Size(215, 115);
                button[i].TabIndex = 0;
                button[i].TextAlign = System.Drawing.ContentAlignment.TopLeft;
                button[i].UseVisualStyleBackColor = false;

                button[i].Text = daten.SignalData[StartIndex + i - 1].Headline;
                button[i].Tag = StartIndex + i - 1; // Index zuweisen

                switch (daten.SignalData[StartIndex + i - 1].Status)
                {
                    case DataItemSignal.SignalStatus.red:
                        button[i].BackColor = Color.Red;
                        break;
                    case DataItemSignal.SignalStatus.green:
                        button[i].BackColor = Color.Green;
                        break;
                    case DataItemSignal.SignalStatus.yellow:
                        button[i].BackColor = Color.Yellow;
                        break;
                }
                button[i].Click += new System.EventHandler(this.button_click);
                this.flowLayoutPanel1.Controls.Add(button[i]);
            }
        }

        private void button_click(object sender, EventArgs e)
        {
            Button button = (Button)sender;
            int index = (int)button.Tag;
            if (daten.SignalData[index].Typ == DataItemSignal.SignalTyp.two)
            {
                // zweibegriffig
                if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.red)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.green;
                    button.BackColor = Color.Green;

                    int adress = daten.SignalData[index].AdressGreen;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceGreen);
                }
                else
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.red;
                    button.BackColor = Color.Red;

                    int adress = daten.SignalData[index].AdressRed;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceRed);
                }

            }
            else
            {
                // dreibegriffig
                if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.red)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.green;
                    button.BackColor = Color.Green;

                    int adress = daten.SignalData[index].AdressGreen;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceGreen);
                }
                else if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.green)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.yellow;
                    button.BackColor = Color.Yellow;

                    int adress = daten.SignalData[index].AdressYellow;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceYellow);
                }
                else
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.red;
                    button.BackColor = Color.Red;

                    int adress = daten.SignalData[index].AdressRed;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceRed);
                }
            }
        }
        
        private void buttonPre_Click(object sender, EventArgs e)
        {
            currentIndex = currentIndex + 12;
            int endIndex = currentIndex + 11;
            if (endIndex > daten.LigthData.Count) endIndex = daten.LigthData.Count;
            buttonBack.Enabled = true;
            if (endIndex <= daten.LigthData.Count)
            {
                buttonPre.Enabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }
        private void buttonBack_Click(object sender, EventArgs e)
        {
            currentIndex = currentIndex - 12;
            int endIndex = currentIndex + 11;
            buttonPre.Enabled = true;
            if (currentIndex <= 1)
            {
                buttonBack.Enabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }

        private void frmSignal_Load(object sender, EventArgs e)
        {
            int number;
            if (daten.SignalData.Count >= 12)
            {
                number = 12;
                if (daten.SignalData.Count > 12) buttonPre.Enabled = true;
            }
            else
            {
                number = daten.SignalData.Count;
                buttonPre.Enabled = false;
                buttonBack.Enabled = false;
            }
            ShowButton(1, number);
        }
    }
}
