﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Train
{
    public partial class frmTrain : Form
    {
        private Data daten;
        private int index = 0;
        public frmTrain()
        {
            InitializeComponent();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

        public void ShowFormAndInput(Data Daten)
        {
            daten = Daten;
            ShowData(index);
            Show();
        }

        private void ShowData(int Index)
        {
            textBoxAdresse.Text = daten.TrainData[Index].Adress.ToString();
            textBoxBezeichnung.Text = daten.TrainData[Index].Description;
            try
            {
                string filename = Application.StartupPath + "\\icons\\" + daten.TrainData[Index].IconFileName;
                pictureBox.Image = Image.FromFile(filename);
            }
            catch
            {
            }
            lblSpeed.Text = daten.TrainData[Index].Speed.ToString();
            if (daten.TrainData[Index].Ligth == true)
            {
                checkBoxLight.Checked = true;
            }
            else
            {
                checkBoxLight.Checked = false;
            }
            checkBoxDirection.Checked = daten.TrainData[Index].Direction;
            if (checkBoxDirection.Checked == true)
            {
                checkBoxDirection.Text = "<<";
            }
            else
            {
                checkBoxDirection.Text = ">>";
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            index++;
            if (index > daten.TrainData.Count - 1) index = 0;
            ShowData(index);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            index--;
            if (index < 0) index = daten.TrainData.Count - 1;
            ShowData(index);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            // aktuelle Lok stoppen
            daten.TrainData[index].Speed = 0;
            lblSpeed.Text = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainStop(daten.TrainData[index].Adress);
        }

        private void SpeedClick(object sender, EventArgs e)
        {
            int delta = Int16.Parse(((Button)sender).Tag.ToString());
            daten.TrainData[index].Speed = daten.TrainData[index].Speed + delta;
            if (daten.TrainData[index].Speed < 0) daten.TrainData[index].Speed = 0;
            if (daten.TrainData[index].Speed > 28) daten.TrainData[index].Speed = 28;
            lblSpeed.Text = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainSpeed(daten.TrainData[index].Adress, daten.TrainData[index].Speed, checkBoxDirection.Checked);
        }

        private void checkBoxLight_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxLight.Checked == true)
            {
                checkBoxLight.BackColor = Color.DarkOrange;
                daten.TrainData[index].Ligth = true;
            }
            else
            {
                checkBoxLight.BackColor = Color.Gainsboro;
                daten.TrainData[index].Ligth = false;
            }
            CommunicationToInterface.LigthOnTrain(daten.TrainData[index].Adress, daten.TrainData[index].Ligth);
        }

        private void checkBoxDirection_Click(object sender, EventArgs e)
        {
            if (checkBoxDirection.Checked == true)
            {
                checkBoxDirection.Text = "<<";
                daten.TrainData[index].Direction = true;
            }
            else
            {
                checkBoxDirection.Text = ">>";
                daten.TrainData[index].Direction = false;
            }
            // Geschwindigkeit auf "0" setzen
            daten.TrainData[index].Speed = 0;
            lblSpeed.Text = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainSpeed(daten.TrainData[index].Adress, daten.TrainData[index].Speed, checkBoxDirection.Checked);
        }
    }
}
